// shadow_erase
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.ExtDlgs, Vcl.ExtCtrls,
  Vcl.StdCtrls, system.UITypes;

type
  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    ScrollBox1: TScrollBox;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    RGBtoHSVbtn: TButton;
    UtamaroBtn: TButton;
    RadioGroup1: TRadioGroup;
    LabeledEdit1: TLabeledEdit;
    RadioGroup2: TRadioGroup;
    LabeledEdit2: TLabeledEdit;
    FileeSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure RGBtoHSVbtnClick(Sender: TObject);
    procedure UtamaroBtnClick(Sender: TObject);
    procedure FileeSaveBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

// ꎟ Iy[^[
  cx0       : array[0..8] of integer = ( 0, 0, 0,     // ꎟ Gradient ʏ̔ Iy[^[
                                         0, 1,-1,
                                         0, 0, 0);
  cy0       : array[0..8] of integer = ( 0, 0, 0,
                                         0, 1, 0,
                                         0,-1, 0);

  cx1       : array[0..8] of integer = ( 1, 0,-1,     // ꎟ Gradient Prewitt    Iy[^[
                                         1, 0,-1,
                                         1, 0,-1);
  cy1       : array[0..8] of integer = ( 1, 1, 1,
                                         0, 0, 0,
                                        -1,-1,-1);

  cx2       : array[0..8] of integer = (-1,-2,-1,     // ꎟ Gradient Soble     Iy[^[
                                         0, 0, 0,
                                         1, 2, 1);
  cy2       : array[0..8] of integer = (-1, 0, 1,
                                        -2, 0, 2,
                                        -1, 0, 1);


// 3 X 3 f[^[op SWZl
  dy        : array[0..8] of integer = (-1,-1,-1,
                                         0, 0, 0,
                                         1, 1, 1);
  dx        : array[0..8] of integer = (-1, 0, 1,
                                        -1, 0, 1,
                                        -1, 0, 1);
var
  InBitmap        : TBitmap;                    // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                    // \[X摜TCY
  H               : array of array of integer;  // F
  S               : array of array of integer;  // ʓx
  V               : array of array of integer;  // x
  grd             : array of array of integer;  // Gradient

// RGB  HSV ϊ[`@Hsu F Saturation ʓx Value x
procedure RGBtoHSV(Red, Green, Blue: Integer; var Hue, Saturation, Value: Integer);
var
  CMax,CMin,CG,R,G,B,H,S,V: Integer;
begin
  H := 0;
  R := Red;
  G := Green;
  B := Blue;
  CMax := Max(R, Max(G, B));
  CMin := Min(R, Min(G, B));
  V := CMax;
  // V = 0 ̎
  if V = 0 then begin
    Hue        := H;
    Saturation := 0;
    Value      := 0;
    exit;
  end;
  // V <> 0 ̎
  S := Round(255 * (CMax - CMin) / CMax);
  if CMax <> CMin then begin
    CG := CMax - CMin;
    if R = CMax then H := Round(60 * (G - B) / CG)
    else
      if G = CMax then H := Round(120 + 60 * (B - R) / CG)
      else
        if B = CMax then H := Round(240 + 60 * (R - G) / CG);
    if H < 0 then H := H + 360;
  end;
  Hue        := H;
  Saturation := S;
  Value      := V;
end;

// HSV  RGB ϊ[`@Hsu F Saturation ʓx Value x
procedure HSVtoRGB(Hue, Saturation, Value: Integer; var Red, Green, Blue: Integer);
var
  M, N, K, Hi: Integer;
  F       : Extended;
begin
  if Saturation = 0 then        // ʓx[̏ꍇ̓O[ OFlł
  begin
    Red   := Value;
    Green := Value;
    Blue  := Value;
  end
  else
  begin // Saturation <> 0
    Hi := Hue div 60;
    F  := Frac(Hue / 60);       // 60Ŋ̒l
    M  := Round(Value * (1 - Saturation / 255));
    N  := Round(Value * (1 - Saturation / 255 * F));
    K  := Round(Value * (1 - Saturation / 255 * (1 - F)));
    case Hi of
      0:  begin
            Red   := Value;
            Green := K;
            Blue  := M;
          end;
      1:  begin
            Red   := N;
            Green := Value;
            Blue  := M;
          end;
      2:  begin
            Red   := M;
            Green := Value;
            Blue  := K;
          end;
      3:  begin
            Red   := M;
            Green := N;
            Blue  := Value;
          end;
      4:  begin
            Red   := K;
            Green := M;
            Blue := Value;
          end;
      5:  begin
            Red   := Value;
            Green := M;
            Blue  := N;
          end;
    end;
  end;
end;

// Pxl̎oB
// ͈͂𒴂̂́A͈͈͂̒͂tɃANZXĒlԂ܂B
function byte_data_read(i, j: integer): double;
begin
  if i < 0 then i := - i;
  if i > Gheight - 1 then i := Gheight + Gheight - 2 - i;    // (Gheight - 1) - (i - (Gheight - 1))
  if j < 0 then j := - j;
  if j > GWidth - 1  then j := GWidth  + GWidth  - 2 - j;    // (GWidth - 1) - (j - (GWidth - 1))
  Result := v[i][j];
end;

// lƁA̖xlw肳ꂽ䗦ŐVxlԂ܂B
// bright͒ʏ255 Grad l Value xl ratio 摜䗦 0`1
function Nextbright(bright, Grad, Value: integer; ratio: double): byte;
var
  NextValue: integer;
begin
  NextValue := bright - Grad;
  if NextValue < 0 then NextValue := 0;
  NextValue := Round((1 - ratio) * NextValue + ratio * Value);
  if NextValue > 255 then NextValue := 255;
  result := NextValue;
end;

// ꎟƔf[^[]Ft
// bright̒lŁAČ摜̖邳ς܂
// bright = 255@
procedure Gradient(rate: double);
const
  bright = 255;
var
  i, j        : integer;
  d           : array[0..8] of double;
  k           : integer;
  xx, yy      : double;
  bp          : pbytearray;
  br, bg, bb  : integer;
  gain          : double;
begin
  val(Form1.LabeledEdit2.Text, gain, br);                     // QC
  if br <> 0 then gain := 1;
  if gain < 0  then gain := 1;
  for i := 0 to GHeight - 1 do begin
    for j := 0 to GWidth - 1 do begin
      for K := 0 to 8 do                                    // x[f[^[o
        d[k] := byte_data_read(i + dy[k],j + dx[k]);
      xx := 0;
      yy := 0;
      for k := 0 to 8 do begin                              // tB^[ s
        case Form1.RadioGroup2.ItemIndex of                 // tB^[̑I
          0: begin                                          // Normal
              xx := xx + cx0[k] * d[k];
              yy := yy + cy0[k] * d[k];
             end;
          1: begin                                          // Prewitt
              xx := xx + cx1[k] * d[k];
              yy := yy + cy1[k] * d[k];
             end;
          2: begin                                          // Soble
              xx := xx + cx2[k] * d[k];
              yy := yy + cy2[k] * d[k];
             end;

        end;
      end;
      grd[i, j] := Round(gain * sqrt(xx * xx + yy * yy));          // ʂ̕ۑ
    end;
  end;
  for i := 0 to GHeight - 1 do begin
    bp := Outbitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      HSVtoRGB(H[i, j], S[i, j], Nextbright(bright, grd[i, j], V[i,j], rate), br, bg, bb);  // rgbɕϊ
      k := j * 3;
      bp[k]     := bb;
      bp[k + 1] := bg;
      bp[k + 2] := br;
    end;
  end;
  Form1.Image2.Picture.Bitmap := OutBitmap;                    // 摜\
end;

// t@C̎wI[v
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        InBitmap.Width    := GWidth;                          // 摜
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap.Width   := GWidth;                          // o͉摜
        OutBitmap.Height  := GHeight;                         // o͉摜
        image1.Picture.Bitmap := InBitmap;                    // 摜\
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  setlength(H, GHeight, GWidth);                              // zf[^[̊m
  setlength(S, GHeight, GWidth);
  setlength(V, GHeight, GWidth);
  setlength(grd, GHeight, GWidth);
  RGBtoHSVbtn.Enabled := True;                                // {^Cl[u
  UtamaroBtn.Enabled  := True;
end;

// FileSave
// TWICImage gpăt@Cۑ
procedure TForm1.FileeSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;                             // t@CZ[utB^[̐ݒ
  if not SavePictureDialog1.Execute then exit;                             // t@Cݒ肳ĂȂ炱܂
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;                                  // gq
  ExeStr := ExtractFileExt(Fname);
  if not WFormatSet then begin
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);
  if Length(FnameTop) = Length(ExeStr) then begin
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;
  try
    WIC.Assign(OutBitmap);
    WIC.ImageFormat := WICF;
    WIC.SaveTofile(Fname);                 // XE3,XE4 ł̓[[N܂B
  finally                                  // AV[v}XLOQƂĉB
    WIC.Free;
  end;

end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  Top := (Screen.Height - Height) div 2;                      // \ʒuݒ
  Left := (Screen.Width - Width) div 2;
  InBitmap      := TBitmap.Create;                            // ͉摜p
  OutBitmap     := TBitmap.Create;                            // o͉摜p
  InBitmap.PixelFormat    := pf24bit;                         // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;                         // 24rbgJ[ɐݒ
  RGBtoHSVbtn.Enabled := False;                               // {^fBu
  UtamaroBtn.Enabled  := False;
end;

// Irbg}bv̔j
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

// RGB  HSV ϊ
procedure TForm1.RGBtoHSVbtnClick(Sender: TObject);
var
  i, j, k     : integer;
  R, G, B     : integer;
  Hd, Sd, Vd  : integer;
  pb      : pbytearray;
begin
  for i := 0 to Gheight - 1 do begin
    pb := Inbitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      k := j * 3;
      B := pb[k];
      G := pb[k + 1];
      R := pb[k + 2];
      RGBtoHSV(R, G, B, Hd, Sd, Vd);
      H[i, j] := Hd;                                          // F
      S[i, j] := Sd;                                          // ʓx
      V[i, j] := Vd;                                          // x
    end;
  end;
  for i := 0 to Gheight - 1 do begin
    pb := OutBitmap.ScanLine[i];
    R := 0;
    for j := 0 to GWidth - 1 do begin
      case RadioGroup1.ItemIndex of                           // WI{^̈ʒuŕ\ύX
        0 : begin
              R := H[i, j];
              if R < 0 then  R := R + 360;
              R := R * 255 div 360;
            end;
        1 : R := S[i, j];
        2 : R := V[i, j];
      end;
      k := j * 3;
      pb[k]     := R;
      pb[k + 1] := R;
      pb[k + 2] := R;
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;
end;

// e̎s
procedure TForm1.UtamaroBtnClick(Sender: TObject);
var
  rate : double;
  check: integer;
begin
  val(LabeledEdit1.Text, rate, check);
  if check <> 0 then begin
    application.MessageBox('̒lɊԈႢ܂B','摜䗦',0);
    exit;
  end;
  if rate > 100 then rate := 100;
  if rate < 0   then rate := 0;
  rate := rate / 100;
  RGBtoHSVbtnClick(nil);
  Gradient(rate);
end;

end.
