// shadow_erase
unit UtamaroMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, system.Types,
  system.Math, system.UITypes;

type
  TForm1 = class(TForm)
    FileOpen: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    ScrollBox1: TScrollBox;
    Image2: TImage;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    UtamaroBtn: TButton;
    LabeledEdit1: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    GrayBtn: TButton;
    GradientBtn: TButton;
    CheckBox1: TCheckBox;
    RadioGroup2: TRadioGroup;
    LabeledEdit2: TLabeledEdit;
    FileeSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure UtamaroBtnClick(Sender: TObject);
    procedure GrayBtnClick(Sender: TObject);
    procedure GradientBtnClick(Sender: TObject);
    procedure FileeSaveBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Type
  TDIarray   = array of array of Double;

const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

// KEVA}XN
  Gaussian3X3 : array[0..8] of integer = (1, 2, 1,
                                          2, 4, 2,
                                          1, 2, 1);
                                   //     4  8  4  v 16
  Total3 = 16;

  Gaussian5X5 : array[0..24] of integer = ( 1,  4,  6,  4,  1,
                                            4, 16, 24, 16,  4,
                                            6, 24, 36, 24,  6,
                                            4, 16, 24, 16,  4,
                                            1,  4,  6,  4,  1);
                                  //       16  64  96  64  16   v 256
  total5 = 256;
// msrbO[XP[W
  kr    = 0.299;                         // O[XP[PxW@
  kg    = 0.587;                         // O[XP[PxW@
  kb    = 0.114;                         // O[XP[PxW@

// ꎟ Iy[^[
  cx0       : array[0..8] of integer = ( 0, 0, 0,     // ꎟ Gradient ʏ̔ Iy[^[
                                         0, 1,-1,
                                         0, 0, 0);
  cy0       : array[0..8] of integer = ( 0, 0, 0,
                                         0, 1, 0,
                                         0,-1, 0);

  cx1       : array[0..8] of integer = ( 1, 0,-1,     // ꎟ Gradient Prewitt    Iy[^[
                                         1, 0,-1,
                                         1, 0,-1);
  cy1       : array[0..8] of integer = ( 1, 1, 1,
                                         0, 0, 0,
                                        -1,-1,-1);

  cx2       : array[0..8] of integer = (-1,-2,-1,     // ꎟ Gradient Soble     Iy[^[
                                         0, 0, 0,
                                         1, 2, 1);
  cy2       : array[0..8] of integer = (-1, 0, 1,
                                        -2, 0, 2,
                                        -1, 0, 1);

  Laplacian4 : array[0..8] of integer = ( 0, 1, 0,     // 񎟔 Laplacian  Iy[^[
                                          1,-4, 1,
                                          0, 1, 0);

  Laplacian8 : array[0..8] of integer = ( 1, 1, 1,     // 񎟔 Laplacian  Iy[^[
                                          1,-8, 1,
                                          1, 1, 1);

// 3 X 3 f[^[op SWZl
  dy        : array[0..8] of integer = (-1,-1,-1,
                                         0, 0, 0,
                                         1, 1, 1);
  dx        : array[0..8] of integer = (-1, 0, 1,
                                        -1, 0, 1,
                                        -1, 0, 1);
  dgy       : array[0..24] of integer = (-2,-2,-2,-2,-2,
                                         -1,-1,-1,-1,-1,
                                          0, 0, 0, 0, 0,
                                          1, 1, 1, 1, 1,
                                          2, 2, 2, 2, 2);
  dgx       : array[0..24] of integer = (-2,-1, 0, 1, 2,
                                         -2,-1, 0, 1, 2,
                                         -2,-1, 0, 1, 2,
                                         -2,-1, 0, 1, 2,
                                         -2,-1, 0, 1, 2);
// Kvϐ̐錾
var
  InBitmap        : TBitmap;                  // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                  // \[X摜TCY
  y               : TDIarray;                 // y  Px
  gr              : TDIarray;                 // Gradient
  gy          : TDIarray;                     // KEVAڂp

// Px(x)l̎o
function byte_data_read_gy(i, j: integer): double;
begin
  if i < 0 then i := - i;
  if i > Gheight - 1 then i := Gheight + Gheight - 2 - i;    // (Gheight - 1) - (i - (Gheight - 1))
  if j < 0 then j := - j;
  if j > GWidth - 1  then j := GWidth  + GWidth  - 2 - j;    // (GWidth - 1) - (j - (GWidth - 1))
  Result := gy[i][j];
end;

// RGBPx(x)zϊ
// KEVAtB^[w肳ĂAKpPx(x)zϊ
procedure rgb_to_y;
var
  i, j, k     : Integer;
  fr, fg, fb  : Double;
  bp          : pbytearray;
  maxd        : Double;
begin
  setlength(y,   GHeight, GWidth);                            // Px(x)lzm
  setlength(gr,  GHeight, GWidth);                            // ʔzm
  if Form1.CheckBox1.Checked then                             // KEVAڂw肳Ă
      setlength(gy,  GHeight, GWidth);                        // KEVApzm
  for i := 0 to GHeight - 1 do begin                          // Px(x)zf[^[쐬
    bp := InBitmap.ScanLine[i];                               // ͉摜C|C^擾
    for j := 0 to GWidth - 1 do begin
      k := j * 3;                                             // PsNZRoCg
      fb := bp[k];                                            // Blue
      fg := bp[k + 1];                                        // Grren
      fr := bp[k + 2];                                        // Red
      maxd := max(fb, max(fg, fr));                           // őlo
      if Form1.CheckBox1.Checked then begin                   // KEVAڂw肳Ă
        gy[i][j] := maxd;                                     // KEVAŝߕʔzɕۑ
//        gy[i][j]  :=  (fb + fg + fr) / 3;                     // Y ϒlvZ
//        gy[i][j]  :=  kr * fr + kg * fg + kb * fb;            // Y NTSCPxlvZ
      end
      else begin
        y[i][j]  := maxd;                                     // w肳ĂȂ疾xzɕۑ
//        y[i][j]  :=  (fb + fg + fr) / 3;                      // Y ϒlvZ
//        y[i][j]  :=  kr * fr + kg * fg + kb * fb;             // Y NTSCPxlvZ
      end;
    end;
  end;
// KEVAtB^[ڂ̎s
  if  Form1.CheckBox1.Checked then begin                      // KEVAڂw肳Ă
    for i := 0 to GHeight - 1 do
      for j := 0 to GWidth - 1 do begin
        maxd := 0;
        if Form1.RadioGroup2.ItemIndex = 0 then begin         // 3X3}XNI
          for k := 0 to 8 do
            maxd := maxd + byte_data_read_gy(i + dy[k], j + dx[K]) * Gaussian3X3[k];
          y[i][j]  := maxd / Total3;                          // ڂxۑ
        end;
        if Form1.RadioGroup2.ItemIndex = 1 then begin         // 5X5}XNI
          for k := 0 to 24 do
            maxd := maxd + byte_data_read_gy(i + dgy[k], j + dgx[K]) * Gaussian5X5[k];
          y[i][j]  := maxd / Total5;                          // ڂxۑ
        end;
      end;
  end;
end;

// Px(x)O[XP[̉摜o
procedure y_to_outBitmap;
var
  i, j, k     : integer;
  bp          : pbytearray;
  fd          : integer;
begin
  for I := 0 to GHeight - 1 do begin
    bp := Outbitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      k := j * 3;
      fd := round(y[i][j]);
      bp[k]     := fd;
      bp[k + 1] := fd;
      bp[k + 2] := fd;
    end;
  end;
  Form1.Image2.Picture.Bitmap := OutBitmap;                    // 摜\
end;

// Pxl̎o
function byte_data_read(i, j: integer): double;
begin
  if i < 0 then i := - i;
  if i > Gheight - 1 then i := Gheight + Gheight - 2 - i;    // (Gheight - 1) - (i - (Gheight - 1))
  if j < 0 then j := - j;
  if j > GWidth - 1  then j := GWidth  + GWidth  - 2 - j;    // (GWidth - 1) - (j - (GWidth - 1))
  Result := y[i][j];
end;

// evZX
// ꎟƔf[^[]Ft
// bright̒lŁAČ摜̖邳ς܂ ől255
// mf 0 e 1 l\
procedure Gradient(percent, gain: double; mf : integer);
const
  bright = 255;
var
  i, j        : integer;
  d           : array[0..8] of double;
  k           : integer;
  xx, yy      : double;
  bp, inp     : pbytearray;
  br, bg, bb  : integer;
  fr, fg, fb, ff: double;
  maxd, ssd   : double;
begin
  for i := 0 to GHeight - 1 do begin
    for j := 0 to GWidth - 1 do begin
      for K := 0 to 8 do                          // Px(x)O[f[^[o
        d[k] := byte_data_read(i + dy[k],j + dx[k]);
      xx := 0;
      yy := 0;
      for k := 0 to 8 do begin
        case Form1.RadioGroup1.ItemIndex of       // tB^[̑I
          0:  begin                               // normal
                xx := xx + cx0[k] * d[k];
                yy := yy + cy0[k] * d[k];
              end;
          1:  begin                               // Prewitt
                xx := xx + cx1[k] * d[k];
                yy := yy + cy1[k] * d[k];
              end;
          2:  begin                               // Soble
                xx := xx + cx2[k] * d[k];
                yy := yy + cy2[k] * d[k];
              end;
          3: xx := xx + Laplacian4[k] * d[k];     // Laplacian
          4: xx := xx + Laplacian8[k] * d[k];     // Laplacian
        end;
      end;
      case Form1.RadioGroup1.ItemIndex of
          0,1,2 : gr[i, j] := round(gain * sqrt(xx * xx + yy * yy));        // l
          3,4   : begin
                    if XX < 0 then XX := 0;                   // vX̂ݍ̗p
                    gr[i, j] := round(gain * XX);
                  end;
      end;
    end;
  end;
// e[`
  if mf = 0 then begin
    for i := 0 to GHeight - 1 do begin
      bp  := Outbitmap.ScanLine[i];                 // o͗prbg}bv
      inp := inbitmap.ScanLine[i];                  // ͉摜rbg}bv
      for j := 0 to GWidth - 1 do begin
        k := j * 3;                                 // PsNZRoCg
        ff := bright - gr[i, j];                    // ePx(x)lvZ gr[]ől Soble1442
        if ff < 0 then ff := 0;                     // Soble Prewitt tB^[̓}CiXɂȂꍇ܂}CiX͍
        fb := inp[k];                               // eF̎o blue
        fg := inp[k + 1];                           //                green
        fr := inp[k + 2];                           //                red
        maxd := max(fb, max(fg, fr));               // ől
        if maxd > 0 then ssd := ff / maxd           // ePx(x)Cv maxd ̓[̎
                    else ssd := 0;                  // maxd [[Zbg
        bb := round(fb * ssd * (1 - percent) + fb * percent);  // blue@vZ elƌ̒l̔䗦vZ
        bg := round(fg * ssd * (1 - percent) + fg * percent);  // green
        br := round(fr * ssd * (1 - percent) + fr * percent);  // red
        bp[k]     := bb;                            // Outbitmapɕۑ blue
        bp[k + 1] := bg;                            //                 green
        bp[k + 2] := br;                            //                 red
      end;
    end;
  end;
// l\
  if mf = 1 then begin
    for i := 0 to GHeight - 1 do begin
      bp  := Outbitmap.ScanLine[i];                 // o͗prbg}bvC|C^
      for j := 0 to GWidth - 1 do begin
        k := j * 3;                                 // PsNZRoCg
        bb := round(gr[i, j]);                      // l
        if bb > 255 then bb := 255;                 // gr[]ől Soble1442
        bp[k]     := bb;                            // Outbitmapɕۑ blue
        bp[k + 1] := bb;                            //                 green
        bp[k + 2] := bb;                            //                 red
      end;
    end;
  end;
  Form1.Image2.Picture.Bitmap := OutBitmap;                    // 摜\
end;

// e[`s
procedure TForm1.UtamaroBtnClick(Sender: TObject);
var
  pp, pf : double;
  c      : integer;
  gain   : double;
begin
  Val(LabeledEdit1.Text, pp, c);
  if c <> 0  then begin
    application.MessageBox('̒lɊԈႢ܂B','}',0);
    exit;
  end;
  if pp > 100 then pp := 100;
  if pp < 0 then pp := 0;
  pf := pp / 100;
  val(LabeledEdit2.Text,gain,c);
  if c <> 0 then begin
    application.MessageBox('Gain̒lɊԈႢ܂B','Gain',0);
    exit;
  end;
  if gain < 0 then gain := 0;
  rgb_to_y;           // Px(x)z쐬
//  y_to_outBitmap;     // Px(x)\
  Gradient(pf, gain, 0);    // evZX
end;

// l\
procedure TForm1.GradientBtnClick(Sender: TObject);
var
  c     : integer;
  gain  : double;
begin
  val(LabeledEdit2.Text,gain,c);
  if c <> 0 then begin
    application.MessageBox('Gain̒lɊԈႢ܂B','Gain',0);
    exit;
  end;
  if gain < 0 then gain := 0;
  rgb_to_y;           // Px(x)z쐬
  Gradient(0,gain, 1);     // l\
end;

// Px(x)\
procedure TForm1.GrayBtnClick(Sender: TObject);
begin
  rgb_to_y;           // Px(x)z쐬
  y_to_outBitmap;     // e
end;

// t@C̃I[v@WIC@t@C̎ނ̂Ŏgp
procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        InBitmap.Width    := GWidth;                          // 摜
        InBitmap.Height   := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
        OutBitmap.Width   := GWidth;                          // o͉摜
        OutBitmap.Height  := GHeight;                         // o͉摜
        image1.Picture.Bitmap := InBitmap;                    // 摜\
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  UtamaroBtn.Enabled := True;
  GrayBtn.Enabled := True;
  GradientBtn.Enabled := True;
end;

// FileSave
// TWICImage gpăt@Cۑ
procedure TForm1.FileeSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;                             // t@CZ[utB^[̐ݒ
  if not SavePictureDialog1.Execute then exit;                             // t@Cݒ肳ĂȂ炱܂
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;                                  // gq
  ExeStr := ExtractFileExt(Fname);
  if not WFormatSet then begin
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);
  if Length(FnameTop) = Length(ExeStr) then begin
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;
  try
    WIC.Assign(OutBitmap);
    WIC.ImageFormat := WICF;
    WIC.SaveTofile(Fname);                 // XE3,XE4 ł̓[[N܂B
  finally                                  // AV[v}XLOQƂĉB
    WIC.Free;
  end;

end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  UtamaroBtn.Enabled := False;
  GrayBtn.Enabled := False;
  GradientBtn.Enabled := False;
  Top := (Screen.Height - Height) div 2;                      // \ʒuݒ
  Left := (Screen.Width - Width) div 2;
  InBitmap      := TBitmap.Create;                            // ͉摜p
  OutBitmap     := TBitmap.Create;                            // o͉摜p
  InBitmap.PixelFormat    := pf24bit;                         // 24rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf24bit;                         // 24rbgJ[ɐݒ
end;

// rbg}bv̉@
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
